﻿using BizService;
using Prism.Commands;
using Prism.Mvvm;
using Prism.Services.Dialogs;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace PLCTool.ViewModels
{
    public class LoginViewModel : BindableBase, IDialogAware
    {
        private readonly IUserService _iUserService;
        public LoginViewModel(IUserService iUserService)
        {
            _iUserService = iUserService;
            ExecuteCommand = new DelegateCommand<string>(Execute);
        }
        public string Title { set; get; } = "登录";

        public event Action<IDialogResult> RequestClose;

        public bool CanCloseDialog()
        {
            return true;
        }

        public void OnDialogClosed()
        {

        }

        public void OnDialogOpened(IDialogParameters parameters)
        {

        }
        private void Execute(string obj)
        {
            switch (obj)
            {
                case "Login": Login(); break;


            }
        }


        /// <summary>
        /// 登录
        /// </summary>
        async void Login()
        {
            if (string.IsNullOrWhiteSpace(UserName) ||
                string.IsNullOrWhiteSpace(PassWord))
            {
                MessageBox.Show("请输入用户名和密码！", "确认", MessageBoxButton.OK, MessageBoxImage.Warning);
                return;
            }
            //进度条设为可见

            if (_iUserService.FindDataByUserAndPass(UserName, PassWord))
            {
                RequestClose?.Invoke(new DialogResult(ButtonResult.OK));
            }
            else
            {
                MessageBox.Show("用户名或密码错误！", "提示", MessageBoxButton.OK, MessageBoxImage.Error);
                return;

            }

        }
        private string userName;

        public string UserName
        {
            get { return userName; }
            set { userName = value; RaisePropertyChanged(); }
        }

        private string password;

        public string PassWord
        {
            get { return password; }
            set { password = value; RaisePropertyChanged(); }
        }

        public DelegateCommand<string> ExecuteCommand { set; get; }
    }
}
